<template>
  <div class="bg-dark text-dark flex scroll">
    <nav class="mb-3">
      <b-navbar-brand :disabled="disabled" class="d-none d-md-block" :to="{name: 'dashboard'}">
        <b-img src="../assets/logoAuthPages.png" width="50" alt="Responsive image"></b-img>
        <span class="ml-1">coronavirus</span>
        <strong>makers</strong>
      </b-navbar-brand>
      <b-nav class="mt-4" vertical>
        <b-nav-item
          v-if="person && persons && persons.length == 1"
          class="pt-1 pb-1"
        >{{ person.name }}</b-nav-item>
        <b-nav-item-dropdown
          v-else-if="person && persons && persons.length > 1"
          :text="person.name"
        >
          <b-dropdown-item
            v-for="(anotherperson, index) in persons"
            :key="index"
            @click="switchPerson(anotherperson)"
          >{{ anotherperson.name }}</b-dropdown-item>
        </b-nav-item-dropdown>
        <h5 class="ml-3 mt-4">Área de trabajo</h5>
        <b-nav-item
          class="pt-1 pb-1"
          :disabled="disabled"
          :active="$route.name == 'dashboard'"
          :to="{name: 'dashboard'}"
        >
          <b-icon-pie-chart-fill class="mr-1 ml-2" />Analítica
        </b-nav-item>
        <b-nav-item
          class="pt-1 pb-1"
          :disabled="disabled"
          :active="$route.name == 'consumerpanel'"
          :to="{name: 'consumerpanel'}"
        >
          <b-icon-heart-half class="mr-1 ml-2" />Pedidos de Demandantes
        </b-nav-item>
        <b-nav-item
          :disabled="disabled"
          class="pt-1 pb-1"
          :active="$route.name == 'producerpanel'"
          :to="{name: 'producerpanel'}"
        >
          <b-icon-wrench class="mr-1 ml-2" />Pedidos de Makers
        </b-nav-item>
        <b-nav-item
          :disabled="disabled"
          class="pt-1 pb-1"
          :active="$route.name == 'intermediatePoints'"
          :to="{name: 'intermediatePoints'}"
        >
          <b-icon-geo class="mr-1 ml-2" />Puntos intermedios
        </b-nav-item>
        <b-nav-item
          :disabled="disabled"
          class="pt-1 pb-1"
          :active="$route.name == 'carriers'"
          :to="{name: 'carriers'}"
        >
          <b-icon-geo-alt class="mr-1 ml-2" />Transportistas
        </b-nav-item>
        <b-nav-item
          :disabled="disabled"
          class="pt-1 pb-1"
          :active="$route.name == 'automatisms'"
          :to="{name: 'automatisms'}"
        >
          <b-icon-shuffle class="mr-1 ml-2" />Automatismos
        </b-nav-item>
        <h5 v-b-toggle.collapse-platform class="ml-3 mt-4">
          Plataforma
          <b-icon-chevron-down class="mr-1 ml-2" />
        </h5>
        <b-collapse id="collapse-platform" class="mt-2">
          <b-nav-item
            :disabled="disabled"
            class="pt-1 pb-1"
            :active="$route.name == 'inventorylist'"
            :to="{name: 'inventorylist'}"
          >
            <b-icon-archive-fill class="mr-1 ml-2" />Inventario
          </b-nav-item>
          <b-nav-item
            :disabled="disabled"
            class="pt-1 pb-1"
            :active="$route.name == 'personlist'"
            :to="{name: 'personlist'}"
          >
            <b-icon-people-fill class="mr-1 ml-2" />Personas
          </b-nav-item>
          <b-nav-item
            :disabled="disabled"
            class="pt-1 pb-1"
            :active="$route.name == 'shippinglist'"
            :to="{name: 'shippinglist'}"
          >
            <b-icon-collection-fill class="mr-1 ml-2" />Envíos
          </b-nav-item>
          <b-nav-item
            :disabled="disabled"
            class="pt-1 pb-1"
            :active="$route.name == 'movelist'"
            :to="{name: 'movelist'}"
          >
            <b-icon-arrow-left-right class="mr-1 ml-2" />Movimientos
          </b-nav-item>
          <b-nav-item
            :disabled="disabled"
            class="pt-1 pb-1"
            :active="$route.name == 'requestlist'"
            :to="{name: 'requestlist'}"
          >
            <b-icon-envelope-fill class="mr-1 ml-2" />Pedidos
          </b-nav-item>
        </b-collapse>

        <h5 class="ml-3 mt-4">Mi cuenta</h5>
        <b-nav-item
          class="ml-1 pt-1 pb-1"
          :active="$route.name == 'profile'"
          :to="{name: 'profile'}"
        >
          <b-icon-person-fill class="mr-1" />Perfil
        </b-nav-item>
        <b-nav-item class="pt-1 ml-1 pb-1" @click="logout">
          <b-icon-power class="mr-1" />Desconectar
        </b-nav-item>
      </b-nav>
    </nav>
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";
export default {
  name: "v-sidebar",
  data() {
    return {};
  },
  props: {
    disabled: {
      type: Boolean,
      default: false
    }
  },
  computed: {
    ...mapState({
      person: state => state.person.person,
      persons: state => state.person.persons
    })
  },
  created() {},
  mounted() {},
  methods: {
    ...mapActions({
      SWITCH_LOGISTICS_PERSON: "person/SWITCH_LOGISTICS_PERSON",
      LOAD_LOGISTIC_PERSON_REGIONS: "person/LOAD_LOGISTIC_PERSON_REGIONS",
      LOADING_START: "apphealth/LOADING_START",
      LOADING_DONE: "apphealth/LOADING_DONE",
      FLUSH_DATA: "person/FLUSH_DATA",
      LOGOUT: "auth/LOGOUT"
    }),
    switchPerson(person) {
      this.LOADING_START();
      // switch vuex and localstorage to person
      this.SWITCH_LOGISTICS_PERSON(person).then(() => {
        // after switching, load regions
        this.LOAD_LOGISTIC_PERSON_REGIONS().then(
          res => {
            if (res.data.count <= 0) {
              this.LOADING_DONE();
              if (this.$route.name != "noRegions") {
                this.$router.push({ name: "noRegions" });
              }
              return;
            }
            this.$router.push({ name: "dashboard" });
            this.LOADING_DONE();
          },
          () => {
            // error al cargar regiones, un 404 significa
            // que no tiene regiones
            this.LOADING_DONE();
            if (this.$route.name != "noRegions") {
              this.$router.push({ name: "noRegions" });
            }
            return;
          }
        );
      });
    },
    logout() {
      this.LOGOUT().then(() => {
        this.FLUSH_DATA();
        this.$router.push({ name: "login" });
      });
    }
  }
};
</script>

<style scoped lang="scss">
$warning: #d9e021;
li {
  a {
    color: $white;
    font-size: 14px;
  }
}
a {
  color: $white;
}
a.nav-brand:hover {
  color: $warning;
}
a:hover {
  color: #fff;
}
.scroll {
  overflow: auto;
  height: 100%;
}
a.active {
  color: $warning;
  &::after {
    position: absolute;
    left: 0;
    margin-top: -8px;
    content: "|";
    color: transparent;
    width: 5px;
    height: 100%;
    background: #d9e021;
    height: 40px;
  }
}
h5 {
  color: #fff;
  font-size: 18px;
}
</style>
